EDIT - feature request #8146

Adapt taxeditor Ul to structure and property term type
02/27/2019 08:37 AM - Patrick Plitzner

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Patrick Plitzner % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.6

Severity: normal

Description

Related issues:

Related to EDIT - feature request #8012: Add termType for Structure and Property Closed
Related to EDIT - feature request #6794: Improve term structure In Progress
Related to EDIT - feature request #8153: Adapt cdmlib to FeatureNode/FeatureT... Closed
Related to EDIT - feature request #8235: Create separate menu for term tree e... Closed

Associated revisions

Revision 34f795b - 02/27/2019 02:21 PM - Patrick Plitzner
ref #8146 Adapt getEmptyDefinedTermBase() for new term types

Revision df0abd11 - 02/27/2019 02:44 PM - Patrick Plitzner

ref #8146 Refactor service method

Revision b6d3c69f - 02/27/2019 03:10 PM - Patrick Plitzner
ref #8146 Add service method for UuidAndTitleCache by termType for trees

Revision defd0d5c - 02/27/2019 03:11 PM - Patrick Plitzner

ref #8146 Restrict term tree selection by termType

Revision 1b28edc1 - 02/28/2019 07:39 AM - Patrick Plitzner

ref #8146 Restrict term tree selection by termType

Revision 47ce5432 - 02/28/2019 12:45 PM - Patrick Plitzner

ref #8146 Fix potential class cast exceptions

e replace deprecated FeatureNode.getFeature() with getTerm()

Revision d4cccf9c - 02/28/2019 12:45 PM - Patrick Plitzner
ref #8146 Add termType to vocabulary selection dialog

Revision b9492486 - 02/28/2019 12:45 PM - Patrick Plitzner

ref #8146 Add termType to feature tree composite and selection dialog

Revision 4832aaf7 - 02/28/2019 12:45 PM - Patrick Plitzner

ref #8146 Add character voc selection in character editor
Revision 1¢59050a - 02/28/2019 12:45 PM - Patrick Plitzner

ref #8146 Restrict tree selection in descriptive data set editor

Revision 62b71512 - 02/28/2019 04:35 PM - Patrick Plitzner

ref #8146 Adapt character matrix to termType model change

Revision d343a6cf - 02/28/2019 04:36 PM - Patrick Plitzner

ref #8146 Adapt feature tree editor and move operation to model change

Revision 77aef047 - 02/28/2019 04:55 PM - Patrick Plitzner

ref #8146 Restrict character matrix to characters

Revision 899c5dee - 03/01/2019 11:08 AM - Patrick Plitzner
ref #8146 Check term type compatibility for drag and drop

Revision de69ffd8 - 03/04/2019 08:51 AM - Patrick Plitzner
ref #8146 Restrict "add term wizard" by termType

Revision 80d9861f - 03/04/2019 09:56 AM - Patrick Plitzner
ref #8146 Check termType in term drop adapter

Revision ae31507c¢ - 03/04/2019 10:16 AM - Patrick Plitzner
ref #8146 i18n for term drop adapter

Revision 3d7968a9 - 03/04/2019 12:18 PM - Patrick Plitzner
ref #8146 Adapt AvailableFeaturesWizard

e temporary disable usage of facet search

Revision daeb8ba2 - 03/20/2019 04:45 PM - Patrick Plitzner
ref #8146 Adapt "add term wizard" to termType restriction

Revision 61dee665 - 04/02/2019 03:49 PM - Patrick Plitzner
ref #8146 Adjust term type check

Revision 6ae3aa93 - 04/03/2019 05:47 PM - Andreas Miiller

ref #8153 adapt ColumnAdder and ColumnTypeChanger to handle NOT NULL correctly for auditing tables

Revision 705a9fe6 - 04/10/2019 07:59 AM - Patrick Plitzner

ref #8146 Show term type of term trees in details view

Revision b2b10e70 - 04/10/2019 12:51 PM - Patrick Plitzner

ref #8146 move term type to top in details view

Revision 80f9d479 - 04/15/2019 03:53 PM - Patrick Plitzner
ref #8146 Adapt getEmptyDefinedTermBase() for new term types

Revision ca48edd7 - 04/15/2019 03:53 PM - Patrick Plitzner

ref #8146 Refactor service method

Revision 754fc710 - 04/15/2019 03:53 PM - Patrick Plitzner
ref #8146 Add service method for UuidAndTitleCache by termType for trees

History

#1 - 02/27/2019 08:37 AM - Patrick Plitzner
- Related to feature request #8012: Add termType for Structure and Property added
#2 - 02/27/2019 08:37 AM - Patrick Plitzner

- Related to feature request #6794: Improve term structure added

#3 - 02/27/2019 02:22 PM - Patrick Plitzner

- Description updated

#4 - 02/27/2019 03:15 PM - Patrick Plitzner

- Description updated

#5 - 02/27/2019 03:15 PM - Patrick Plitzner
- Description updated

#6 - 02/28/2019 08:03 AM - Patrick Plitzner
- Description updated

#7 - 02/28/2019 08:03 AM - Patrick Plitzner
- Description updated

#8 - 02/28/2019 08:07 AM - Patrick Plitzner
Add character to term menu with 2c98dda6165033a58¢7df8c06b21518d380307b3

#9 - 03/04/2019 11:53 AM - Patrick Plitzner
- Priority changed from New to Highest

#10 - 03/04/2019 12:19 PM - Patrick Plitzner
- Description updated
- Priority changed from Highest to New

#11 - 03/04/2019 12:48 PM - Patrick Plitzner
- Priority changed from New to Highest

#12 - 03/28/2019 08:33 AM - Patrick Plitzner
- Status changed from New to Resolved

- % Done changed from 0 to 50

#13 - 04/03/2019 01:22 PM - Patrick Plitzner

- Assignee changed from Patrick Plitzner to Katja Luther

For review check the points in the description and play around with vocabularies and trees of different term types.

Check if the type check is correct:
*Vocabulary can only contain terms of their own type.
*TermTrees can only contain TermNodes of their type. The term of the TermNode can, however, be a subtype of the node's type

#14 - 04/03/2019 03:09 PM - Katja Luther

deleting a feature from termTree throws an exception but removing is successful

login : admin
editor version : 5.6.0.qualifier
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 5.5.0.0.20190221
os : Windows 7 6.1 amdé4
java : 1.8.0_171
org.eclipse.swt.SWIException: Failed to execute runnable (org.springframework.dao.DatalIntegrityViolationExcept
ion: could not execute statement; SQL [n/a]; constraint [null]; nested exception is org.hibernate.exception.Co
nstraintViolationException: could not execute statement)
at org.eclipse.swt.SWT.error (SWT. java:4533)
at org.eclipse.swt.SWT.error (SWT. java:4448)
at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer. java:185)
at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4211)
at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3827)
at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine.java:1121)
at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine.java:1022)
at org.eclipse.ed.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application.java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher. java:134

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher.java:104)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:388)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)
at sun.reflect.NativeMethodAccessorImpl.invoke0 (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (Unknown Source)

at java.lang.reflect.Method.invoke (Unknown Source)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)

at org.eclipse.equinox.launcher.Main.run (Main.java:1519)

at org.eclipse.equinox.launcher.Main.main (Main. java:1492)

Caused by: org.springframework.dao.DatalntegrityViolationException: could not execute statement; SQL [n/al; co
nstraint [null]; nested exception is org.hibernate.exception.ConstraintViolationException: could not execute s
tatement

at org.springframework.orm.hibernate5.SessionFactoryUtils.convertHibernateAccessException (SessionFactoryUt
ils.java:164)

at org.springframework.orm.hibernate5.HibernateTransactionManager.convertHibernateAccessException (Hibernat
eTransactionManager. java:741)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (HibernateTransactionManager. jav
a:589)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.processCommit (AbstractPlatfo
rmTransactionManager. java:761)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.commit (AbstractPlatformTrans
actionManager.java:730)

at org.springframework.transaction.interceptor.TransactionAspectSupport.commitTransactionAfterReturning (Tr
ansactionAspectSupport.java:485)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Transactio
nAspectSupport. java:291)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterceptor. java:9
6)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17
9)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy695.deleteFeatureNode (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokedJoinpoint (ReflectiveMethodInvocation
.java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15
7)

at org.springframework.remoting.support.RemoteInvocationTracelInterceptor.invoke (RemoteInvocationTraceInter
ceptor.java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17
9)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy982.deleteFeatureNode (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemoteInvocation. java:212)

at org.springframework.remoting.support.DefaultRemoteInvocationExecutor.invoke (DefaultRemoteInvocationExec
utor.java:39)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (RemotelInvocationBasedExporter
.java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCreateResult (RemoteInvocati
onBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleRequest (HttpInvokerServiceExp
orter.java:74)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandlerAdapter.java:51)
web.
web.
web.
web.
web.
web.
web.

.springframework.security.web.

session.

handler.
.handler.
handler.
Server.handle (Server.java:497)

.DispatcherServlet.doDispatch (DispatcherServlet. java:959)
.DispatcherServlet.doService (DispatcherServlet. java:893)
servlet.FrameworkServlet.processRequest (FrameworkServlet. java:969)
.FrameworkServlet.doPost (FrameworkServlet.java:871)
javax.servlet.http.HttpServlet.service (HttpServlet. java:707)
org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet. java:845)
javax.servlet.http.HttpServlet.service (HttpServlet. java:790)

eclipse. jetty.servlet.ServletHolder.handle (ServletHolder. java:808)

eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1669)

.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:316
access.intercept.FilterSecurityInterceptor.invoke (FilterSecurityInterc
access.intercept.FilterSecurityInterceptor.doFilter (FilterSecurityInte
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
access.ExceptionTranslationFilter.doFilter (ExceptionTranslationFilter.
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
session.SessionManagementFilter.doFilter (SessionManagementFilter. java:
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
servletapi.SecurityContextHolderAwareRequestFilter.doFilter (SecurityCo
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
savedrequest .RequestCacheAwareFilter.doFilter (RequestCacheAwareFilter.
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:330

.authentication.www.BasicAuthenticationFilter.doFilterInternal (BasicAut

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:330
120)

java:

.authentication.logout.LogoutFilter.doFilter (LogoutFilter. java:
.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. 330

.header.HeaderWriterFilter.doFilterInternal (HeaderWriterFilter. java:64)

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330
.context.SecurityContextPersistenceFilter.doFilter (SecurityContextPersi

.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

.context.request.async.WebAsyncManagerIntegrationFilter.doFilterInterna
:53)

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:330

.FilterChainProxy.doFilterInternal (FilterChainProxy. java:213)
.FilterChainProxy.doFilter (FilterChainProxy. java:176)

web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterProxy. java:346)
web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy.java:262)
eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)
springframework.web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodingFilter. java:12

springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)
.servlet.ServletHandler.doHandle (ServletHandler. java:585)

.ScopedHandler.handle (ScopedHandler. java:143)

security.SecurityHandler.handle (SecurityHandler. java:577)

.SessionHandler.doHandle (SessionHandler. java:223)
.ContextHandler.doHandle (ContextHandler. java:1127)

servlet.ServletHandler.doScope (ServletHandler. java:515)

SessionHandler.doScope (SessionHandler. java:185)
.ContextHandler.doScope (ContextHandler. java:1061)
ScopedHandler.handle (ScopedHandler. java:141)
ContextHandlerCollection.handle (ContextHandlerCollection. java:215)
HandlerWrapper.handle (HandlerWrapper. java:97)
at org.eclipse. jetty.server.HttpChannel.handle (HttpChannel. java:310)

at org.eclipse. jetty.server.HttpConnection.onFillable (HttpConnection. java:257)

at org.eclipse.jetty.io.AbstractConnection$2.run (AbstractConnection.java:540)

at org.eclipse.jetty.util.thread.QueuedThreadPool.runJob (QueuedThreadPool. java:635)

at org.eclipse.jetty.util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)

at java.lang.Thread.run (Thread. java:748)

at org.springframework.remoting.support.RemoteInvocationUtils.fillInClientStackTraceIlfPossible (RemoteInvoc
ationUtils.java:45)

at org.springframework.remoting.support.RemoteInvocationResult.recreate (RemoteInvocationResult.java:149)

at org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemoteInvocationResult (Remot
eInvocationBasedAccessor. java:85)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerClientIntercept
or.java:150)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17
9)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$Proxy55.deleteFeatureNode (Unknown Source)

at eu.etaxonomy.taxeditor.featuretree.ed.operation.RemoveFeatureOperation.execute (RemoveFeatureOperation. j
ava:40)

at eu.etaxonomy.taxeditor.model.AbstractUtility.lambda$3 (AbstractUtility.java:147)

at org.eclipse.ui.internal.UILockListener.doPendingWork (UILockListener.java:162)

at org.eclipse.ui.internal.UISynchronizer$3.run (UISynchronizer. java:154)

at org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:182)

24 more

Caused by: org.hibernate.exception.ConstraintViolationException: could not execute statement

at org.hibernate.exception.internal.SQLExceptionTypeDelegate.convert (SQLExceptionTypeDelegate. java:59)

at org.hibernate.exception.internal.StandardSQLExceptionConverter.convert (StandardSQLExceptionConverter. ja
va:42)

at org.hibernate.engine. jdbc.spi.SglExceptionHelper.convert (SglExceptionHelper.java:109)

at org.hibernate.engine. jdbc.spi.SglExceptionHelper.convert (SgqlExceptionHelper. java:95)

at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetReturnImpl. java:207)

at org.hibernate.engine. jdbc.batch.internal.NonBatchingBatch.addToBatch (NonBatchingBatch. java:45)

at org.hibernate.persister.entity.AbstractEntityPersister.insert (AbstractEntityPersister.java:2886)

at org.hibernate.persister.entity.AbstractEntityPersister.insert (AbstractEntityPersister.java:3386)

at org.hibernate.action.internal.EntityInsertAction.execute (EntityInsertAction.java:89)

at org.hibernate.engine.spi.ActionQueue.executeActions (ActionQueue. java:560)

at org.hibernate.engine.spi.ActionQueue.executeActions (ActionQueue. java:434)

at org.hibernate.event.internal.AbstractFlushingEventListener.performExecutions (AbstractFlushingEventListe
ner.java:337)

at org.hibernate.event.internal.DefaultFlushEventListener.onFlush (DefaultFlushEventListener. java:39)

at org.hibernate.internal.SessionImpl.flush(SessionImpl.java:1282)

at org.hibernate.envers.internal.synchronization.AuditProcess.doBeforeTransactionCompletion (AuditProcess.j
ava:156)

at org.hibernate.envers.internal.synchronization.AuditProcessManager$l.doBeforeTransactionCompletion (Audit
ProcessManager. java:46)

at org.hibernate.engine.spi.ActionQueue$BeforeTransactionCompletionProcessQueue.beforeTransactionCompletio
n (ActionQueue. java:899)

at org.hibernate.engine.spi.ActionQueue.beforeTransactionCompletion (ActionQueue. java:481)

at org.hibernate.internal.SessionImpl.beforeTransactionCompletion (SessionImpl. java:2340)

at org.hibernate.engine. jdbc.internal.JdbcCoordinatorImpl.beforeTransactionCompletion (JdbcCoordinatorImpl.
java:485)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTransactionCoordinatorImpl.be
foreCompletionCallback (JdbcResourcelLocalTransactionCoordinatorImpl. java:147)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordinatorImpl.ac
cess$100 (JdbcResourcelocalTransactionCoordinatorImpl. java:38)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTransactionCoordinatorImpls$Tr
ansactionDriverControlImpl.commit (JdbcResourcelLocalTransactionCoordinatorImpl. java:231)

at org.hibernate.engine.transaction.internal.TransactionImpl.commit (TransactionImpl. java:65)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (HibernateTransactionManager. jav
a:581)

... 126 more
Caused by: java.sgl.SQLIntegrityConstraintViolationException: Column 'termType' cannot be null

at com.mysgl.cj.jdbc.exceptions.SQLError.createSQLException (SQLError. java:117)

at com.mysqgl.cj.jdbc.exceptions.SQLError.createSQLException (SQLError. java:97)

at com.mysgl.cj.jdbc.exceptions.SQLExceptionsMapping.translateException (SQLExceptionsMapping. java:122)

at com.mysqgl.cj.jdbc.ClientPreparedStatement.executeInternal (ClientPreparedStatement. java:970)

at com.mysqgl.cj.jdbc.ClientPreparedStatement.executeUpdateInternal (ClientPreparedStatement. java:1109)

at com.mysgl.cj.jdbc.ClientPreparedStatement.executeUpdateInternal (ClientPreparedStatement.java:1057)

at com.mysqgl.cj.jdbc.ClientPreparedStatement.executelargeUpdate (ClientPreparedStatement. java:1377)

at com.mysgl.cj.jdbc.ClientPreparedStatement.executeUpdate (ClientPreparedStatement. java:1042)

at com.mchange.v2.c3p0.impl.NewProxyPreparedStatement.executeUpdate (NewProxyPreparedStatement. java:384)

at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetReturnImpl. java:204)

146 more
#15 - 04/03/2019 03:15 PM - Katja Luther

e restricting tree selection seems to work
¢ drag&drop of terms into a term tree works as expected

#16 - 04/03/2019 03:51 PM - Patrick Plitzner
Katja Luther wrote:
deleting a feature from termTree throws an exception but removing is successful

This exception is only thrown due to legacy data. TermTrees and -Nodes without termType set should not exist anymore. On which DB did you test?
Maybe the update script did not run completely.

#17 - 04/03/2019 03:57 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Katja Luther to Andreas Miiller
Patrick Plitzner wrote:
Katja Luther wrote:
deleting a feature from termTree throws an exception but removing is successful

This exception is only thrown due to legacy data. TermTrees and -Nodes without termType set should not exist anymore. On which DB did you
test? Maybe the update script did not run completely.

DB you find in log. cdm_rem_conf_am.
| guess the reason is FeatureNode_AUD.termType which is NOT NULL. This is probably an issue in the update script. | take this ticket to further
investigate.

#18 - 04/03/2019 05:56 PM - Andreas Miiller
- Related to feature request #8153: Adapt cdmlib to FeatureNode/Feature Tree model changes added

#19 - 04/03/2019 05:59 PM - Andreas Miiller
- Status changed from Feedback to Resolved

- Assignee changed from Andreas Miiller to Katja Luther

| adjusted the update script. To test if the script works correctly now we should take a production database and move it to test or to localhost and test
the update. Test if TaxonNode_AUD.termType is set to allow NULL as it should.

On rem_conf_am (and all other databases on test) | updated manually so you can continue testing this ticket.

#20 - 04/04/2019 07:11 AM - Patrick Plitzner

- Assignee changed from Katja Luther to Patrick Plitzner

#21 - 04/04/2019 07:45 AM - Patrick Plitzner
- File picture937-1.png added

- Assignee changed from Patrick Plitzner to Katja Luther

| copied additivity_ontology to my local DBs and connected with the taxeditor. Seems like it worked.
W DEIVED dlalus

2 Client Connections Info | Columns || Indexes | Triggers || Foreign keys || Partitions || Grants
——

j_ Users and Privileges

Column Type Default Value | Nullable| Character Set Collation Privileges Extr
Stat d Systs Variabl . . .
(=] Status and System Variables > id int(11) NO select,insert,update,references
X, Data Export ) .
> REV int{11) NO select,insert,update,references
;i; Data Import/Restore ) )
> REVTYPE tinyint(4) YES select,insert,update,references
Lemes > created datetime YES select,insert,update,references
g ST ST > uuid varchar(36) YES utfg utf8_general_ci select,insert,update,references
Server Logs . =
d > updated datetime YES select,insert,update,references
A~ Options File ) )
» sortindex int{11) YES select,insert,update,references
R > treelndex varchar(255) YES utfg utf8_general_ci select,insert,update,references
Q_f R > createdBy id int(11) YES select,insert,update, references
7| Perf Reports L .
Sl e e > updatedBy_id int(11) YES select,insert,update,references
o‘\ Performance Schema Setup i i i
> feature_id int(11) YES select,insert,update,references
» featureTree_id int(11 YES select,insert,update, references
SCHEMAS B " i id int(11) | : pd i
Filter objects > parent_i in select,insert,update,references
Q parent_id t(11) YES lect,insert,update, refe
» ExternalLink_LanguageString_AUD w*‘——“ = |
» E FeatureNode
El /
» Columns :
~ [ Indexes | I

#22 - 04/05/2019 09:59 AM - Katja Luther
- Status changed from Resolved to Feedback

- Assignee changed from Katja Luther to Patrick Plitzner

tested on nightly:

open term editor for structures, create a new vocabulary, try drag&drop from one vocabulary to the another -> works
open term editor for properties try to drag&drop a term of type structure to a vocabulary of properties -> message box that the term hast not the same
type as the vocabulary

in character editor:
selection dialogs show only the correct vocabularies.

in term tree editor:
tried to add features to different term trees and only the correct vocabularies are available to select a term

Maybe it would be nice to have a possibility to distinguish between the term tree types. neither in details view nor in term tree editor it is shown which
type of terms are allowed.

#23 - 04/05/2019 03:41 PM - Patrick Plitzner
Katja Luther wrote:
Maybe it would be nice to have a possibility to distinguish between the term tree types. neither in details view nor in term tree editor it is shown

which type of terms are allowed.

We could add the termtype to the label of term trees and terms and maybe make it toggleable in the preferences. Also in the details view it should be
shown

#24 - 04/10/2019 07:59 AM - Patrick Plitzner
- Status changed from Feedback to Resolved

- Assignee changed from Patrick Plitzner to Katja Luther

| added the term type for feature trees to the details view. Is this ok?
We may think about further options in the next release.

#25 - 04/10/2019 12:07 PM - Katja Luther
- Status changed from Resolved to Feedback
- Assignee changed from Katja Luther to Patrick Plitzner

Patrick Plitzner wrote:

| added the term type for feature trees to the details view. Is this ok?
We may think about further options in the next release.
| would put the termtype above the name, because it is more like an description.

#26 - 04/10/2019 12:51 PM - Patrick Plitzner
- Status changed from Feedback to Resolved
- Assignee changed from Patrick Plitzner to Katja Luther

- % Done changed from 50 to 80

Katja Luther wrote:
Patrick Plitzner wrote:
| added the term type for feature trees to the details view. Is this ok?
We may think about further options in the next release.

| would put the termtype above the name, because it is more like an description.

| moved the termType to the top

#27 - 04/10/2019 12:53 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller
Patrick Plitzner wrote:
| added the term type for feature trees to the details view. Is this ok?

We may think about further options in the next release.

@Patrick: Please open a new ticket for this discussion,
@Andreas M. Then we can close this ticket?

#28 - 04/10/2019 01:04 PM - Patrick Plitzner

Katja Luther wrote:
Patrick Plitzner wrote:

| added the term type for feature trees to the details view. Is this ok?
We may think about further options in the next release.

@Patrick: Please open a new ticket for this discussion,
@Andreas M. Then we can close this ticket?

new ticket #8235

#29 - 04/10/2019 01:05 PM - Patrick Plitzner

- Related to feature request #8235: Create separate menu for term tree editors for each term tree type added

#30 - 04/11/2019 09:50 AM - Andreas Muller

Why not using the term type in the label, e.g. instead of FeatureTree => Structure Tree. Then users must not think about what a term type means if
the label says "Feature Tree". Also it is not consistent to have term type structure under the label "FeatureTree". However, this is a minor issue and if
we implement the term type specific Term Tree editors soon we may keep it as it is for now.

#31 - 04/11/2019 09:56 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Patrick Plitzner

Generally it should be possible to move a Character subtree to a Feature tree as Character is a subtype. But of course then all term nodes need to
change its term type to the more general term type "Feature". We have discussed this already on cdmlib level for the "add" method. Please open a
new ticket for this issue as probably it is not simple enough to be implemented still in this ticket.

Also the other way round we need to discuss. Feature nodes may be moved to character trees if and only if all the feature nodes contain characters.
This is important to make the operation reversable. But it requires an additional check if the condition holds and user feedback if the operation is not
https://dev.e-taxonomy.eu/redmine/issues/8235

possible.

#32 - 04/11/2019 09:57 AM - Andreas Muller

All the rest seems to work and ticket can be closed then.

#33 - 04/11/2019 11:20 AM - Patrick Plitzner
- Status changed from Feedback to Closed
- % Done changed from 80 to 100

Added #8146#note-30 to #8235

Created #8238 for #8146#note-31

Closing this ticket
